#!/usr/bin/perl

##################################################################
## Computation of STEC rates (used for AATR index) and double 	##
## differences (used for MSTID index). Reads and prints  		##
## in STDIN and STDOUT, respectively.							##
##################################################################

$,=" ";
$\="\n";
$|=1;

#Variable definition
$ndata=0;
$r_earth=6370;
$h_ion=350;
$g2r=atan2(1,1)/45;
$tau=30;

#Reading the standard input
open (F1,"sta.coor");
@sta_list=();
while (<F1>) {
chop;
@d=split(' ',$_,9);
for $i (0..2) {
	$coor_sta0{$d[0]." ".$i}=$d[$i+1];
              }
	$coor_sta0{$d[0]." 0"}=$coor_sta0{$d[0]." 0"}/1000.;
             }

	@d=split(' ',`tail -1 model.log`,15);

	$sun_lat=$d[10];
	$sun_lt=$d[9]+$d[2]*15/3600;

while (<STDIN>) {
chop;
	@d=split(' ',$_,33);
	$ndata++;
	if ($ndata==1) {$doy0=$d[1]}
	if ($d[2]%30==0) {
	$t=($d[1]-$doy0)*86400+$d[2];

	for $i (0..2) {$coor_sta[$i]=$coor_sta0{$d[3]." ".$i}}
	@los=@d[13..15];
	@coor_pp=pp(@coor_sta,@los);


	$a=$t." ".$d[3]." ".$d[5]." ".$d[10];

	$b1=eval($t-$tau)." ".$d[3]." ".$d[5]." ".$d[10];
	$b5=eval($t-5*$tau)." ".$d[3]." ".$d[5]." ".$d[10];
	$b10=eval($t-10*$tau)." ".$d[3]." ".$d[5]." ".$d[10];
	$b20=eval($t-20*$tau)." ".$d[3]." ".$d[5]." ".$d[10];

	$p_i{$a}=$d[9]-$d[8];
	$l_i{$a}=$d[6]-$d[7];
	$ipp_lat{$a}=$coor_pp[2];
	$ipp_lon{$a}=$coor_pp[1];
	$map_2=1/(1-($r_earth*cos($d[20]*$g2r)/($r_earth+$h_ion))**2);
	if ($p_i{$b1} && $p_i{$b5} && $p_i{$b10} && $p_i{$b20}) {
	$curv1=(0.5*($l_i{$a}+$l_i{$b10})-$l_i{$b5})/$map_2;
	$curv2=(0.5*($l_i{$a}+$l_i{$b20})-$l_i{$b10})/$map_2;
	$rate=($l_i{$a}-$l_i{$b1})/$tau;
	$v_ipp=117.*sqrt((cos($ipp_lat{$a}*$g2r)*($ipp_lon{$a}-$ipp_lon{$b1}))**2+($ipp_lat{$a}-$ipp_lat{$b1})**2)/$tau;
	if ($curv1**2>-2.65 || $curv2**2>-2.5 || $rate**2>-1e-4) {
	printf "%-18s %10.7f %10.7f %10.7f %10.7f %10.7f %10.7f %9.5f %8.5f %8.5f %8.5f %9.5f\n",$a,$curv1,$curv2,$rate,$v_ipp,$map_2,$ipp_lon{$a},$ipp_lat{$a},@d[13..15],$coor_pp[3];
                                      }
                                   }
                    }
                }
#Subroutines

sub pp {
my @d = @_;
my (@r_sta);
my (@r_sat);
my (@r_pp);
my (@a); my (@v); my ($il);my ($vmod);my ($r_v);my ($ss);
$r_sta[0]=$d[0]*cos($d[2]*$g2r)*cos($d[1]*$g2r);
$r_sta[1]=$d[0]*cos($d[2]*$g2r)*sin($d[1]*$g2r);
$r_sta[2]=$d[0]*sin($d[2]*$g2r);
$r_sat[0]=$r_sta[0]+1.e5*$d[3];
$r_sat[1]=$r_sta[1]+1.e5*$d[4];;
$r_sat[2]=$r_sta[2]+1.e5*$d[5];;
$vmod=0;
	for $il (0..2){
	$v[$il]=$r_sat[$il]-$r_sta[$il];
	$vmod=$vmod+$v[$il]**2;
		      }
$vmod=sqrt($vmod);
$r_v=0;
	for $il (0..2){
	$v[$il]=$v[$il]/$vmod;
	$r_v=$r_v+$v[$il]*$r_sta[$il];
		      }
$ss=-1*$r_v+sqrt($r_v**2+($d[0]+$h_ion)**2-$d[0]**2);
@r_pp=(0)x3;
$sun_lon=$sun_lt-$t*15/3600;
$r_sun[0]=cos($sun_lat*$g2r)*cos($sun_lon*$g2r);
$r_sun[1]=cos($sun_lat*$g2r)*sin($sun_lon*$g2r);
$r_sun[2]=sin($sun_lat*$g2r);

$v_sun=0;
	for $il (0..2){
	$r_pp[$il]=$r_sta[$il]+$ss*$v[$il];
	$v_sun=$v_sun+$r_sun[$il]*$r_pp[$il];
		      }
$a[0]=sqrt($r_pp[0]**2+$r_pp[1]**2+$r_pp[2]**2);
$a[1]=atan2($r_pp[1],$r_pp[0])/$g2r;
$a[2]=atan2($r_pp[2],sqrt($r_pp[0]**2+$r_pp[1]**2))/$g2r;
$a[3]=$v_sun/$a[0];
return @a;


       }
