#!/usr/bin/perl

#################################################################
# This program computes the lunisolar and ocean loading tides	#
# for a receiver (introduced as argument).						#
# The program search the receiver coordinates in "sta.coor"		#
#																#
# Scherneck														#
#################################################################
$,=" ";
$\="\n";
$[=1;
$|=1;

$g2r=atan2(1,1)/45;

$sta=$ARGV[1];
$year=$ARGV[2];
if (length($year)==1) {$year="0".$year}
$doy=$ARGV[3];
$d_t=$ARGV[4];

$num=2*int(86400/$d_t)+1;

open (F1,"sta.coor");

while (<F1>) {
chop;
@d=split(' ',$_,19);
if (uc($d[1]) eq uc($sta)) {
$r_sta[1]=$d[2]*1e-3*cos($d[4]*$g2r)*cos($d[3]*$g2r);
$r_sta[2]=$d[2]*1e-3*cos($d[4]*$g2r)*sin($d[3]*$g2r);
$r_sta[3]=$d[2]*1e-3*sin($d[4]*$g2r);
$r_sta_mod=$d[2]*1e-3;
$lon=$d[3];
$lat=$d[4];
                    }
             }

open (F1,"../info_files/ocnld_coeffs");
open(F6,"> ol.log");

$cos_angle_max=-1;
while (<F1>) {
@d=split(' ',$_,20);
chop;

##### ATENCION el lugar de los campos es distinto en GIPSY
if ($d[3] eq "lon/lat:") {
$r[1]=cos($d[5]*$g2r)*cos($d[4]*$g2r);
$r[2]=cos($d[5]*$g2r)*sin($d[4]*$g2r);
$r[3]=sin($d[5]*$g2r);
###if ($d[5] eq "lon/lat:")  {
##$r[1]=cos($d[7]*$g2r)*cos($d[6]*$g2r);
###$r[2]=cos($d[7]*$g2r)*sin($d[6]*$g2r);
###$r[3]=sin($d[7]*$g2r);
$cos_angle=0.0;
for $i (1..3) {$cos_angle=$cos_angle+$r[$i]*$r_sta[$i]/$r_sta_mod;}
####if ($cos_angle>0.9998 && $cos_angle_max < $cos_angle) {
if ($cos_angle>0.998 && $cos_angle_max < $cos_angle) {
$cos_angle_max=$cos_angle;
print (F6 @d," at ",6.37e3*atan2(sqrt(1-$cos_angle**2),$cos_angle)," km");
for $i (1..6) {
$c=<F1>;
chop $c;
$oc_line[$i]=$c;
              }
                                                      }

                         }

             }

open (F2,"> ol.coef");
for $i (1..3) {
@c=split(' ',$oc_line[$i],14);
printf (F2 " ");
for $j (1..11) {printf (F2 "%7.5f",$c[$j])}
print (F2 "");
              }

for $i (4..6) {
@c=split(' ',$oc_line[$i],14);
printf (F2 " ");
for $j (1..11) {printf (F2 "%7.1f",$c[$j])}
print (F2 "");     
              }



open (F2,"|uniq |../prefits_bin/tide_iers > lunisolar_tide.dat");
open (F4,"> ol_tide.dat");

for $idata (0..$num) {
&doy2month($year,$doy);
$t=$idata*$d_t;
printf (F2 "%02d %3d %2d %2d %6d %10.6f %10.6f %10.6f\n",$year,$doy,$month,$day,$t,@r_sta);

if ($idata==0) {
print $year,$doy,0,0,0,$num,$d_t;
`cat ol.coef|../prefits_bin/hardisp $year $doy 0 0 0 $num $d_t > ol.tmp` ;

open (F3,"ol.tmp");
$jdata=0;
while (<F3>) {
@b=split(' ',$_,6);
@a=rot(3,-1*$lon*$g2r,rot(2,$lat*$g2r,rot(1,90*$g2r,@b)));
for $i (1..3) {$ol_tide{int($jdata*$d_t)." ".$i}=$a[$i]}
printf (F4 "%6d %7.4f %7.4f %7.4f\n",$jdata*$d_t,@a);
$jdata++
             }

               }


$idata++;
                     }


open (F2,"> tides.dat");
open (F1,"lunisolar_tide.dat");
while(<F1>) {
chop;
@d=split(' ',$_,8);
printf (F2 "%6d %7.4f %7.4f %7.4f     %7.4f %7.4f %7.4f\n",@d[1..4],$ol_tide{int($d[1])." 1"},$ol_tide{int($d[1])." 2"},$ol_tide{int($d[1])." 3"});
           }




sub doy2month{
my @d=@_;
$in_month=int($d[2]/28)+1;
if ($in_month>12) {$in_month=12}
$in_doy=`date -u -d$d[1]"-"$in_month"-01" +"%j"`;
$day=$d[2]-$in_doy+1;
if ($day <= 0) {
$in_month=$in_month-1;
$in_doy=`date -u -d$d[1]"-"$in_month"-01" +"%j"`;
$day=$d[2]-$in_doy+1;
              }
$month=$in_month;
return $month,$day;
              }

sub rot {
my @d = @_;
if ($d[1]==1) {
$r[1]=$d[3];
$r[2]=$d[4]*cos($d[2])+$d[5]*sin($d[2]);
$r[3]=-1*$d[4]*sin($d[2])+$d[5]*cos($d[2]);
return @r;
              }
if ($d[1]==2) {
$r[1]=$d[3]*cos($d[2])-$d[5]*sin($d[2]);
$r[2]=$d[4];
$r[3]=$d[3]*sin($d[2])+$d[5]*cos($d[2]);
return @r;
              }
if ($d[1]==3) {
$r[1]=$d[3]*cos($d[2])+$d[4]*sin($d[2]);
$r[2]=-$d[3]*sin($d[2])+$d[4]*cos($d[2]);
$r[3]=$d[5];
return @r;
              }
         }

