#!/usr/bin/perl
#######################################################################
## This script detects leap miliseconds that are not explicit on the ##	
## rinex time record. 												 ##
## Works over the output of rnx2txt.pl								 ##
#######################################################################

$,=" ";
$\="\n";
$[=1;
$|=1;

##################CONSTANTS
$c_light=299792458;
$f0=10.23e6;
$f[1]=1575.42e6;
$f[2]=1227.60e6;
$f2_gps=1227.60e6;
$f[5]=1176.45e6;
$f[6]=1278.75e6;
$f[7]=1207.140e6;
$f[8]=1191.795e6;

open (F2,"> detect_phase_leapms.log");

$line=0;
$ndata=0;
$t0=-10000;
%l=();%p=();@sats=();



while (<>) {
$ndata++;
chop;
@d=split(' ',$_,25);
$gnss_type=substr($d[5],1,1);
if (($d[4] ne $sta || $d[3]!=$t0) && $ndata>1) {goto label1}
$line++;
$all_line[$line]=$_;
$sat=$d[5]." ".$d[6];
$sta=$d[4];
$freq_num{$sat}=length($d[5])-1;
push(@sats,$sat);
for $i (1..$freq_num{$sat})   {
$l{$sta." ".$sat." ".$i}=$d[6+$i];
$p{$sta." ".$sat." ".$i}=$d[6+$freq_num{$sat}+$i];
                               }
goto label0;

label1:
### check for a leapms
$n_leaps=0;
$max_leap=0;
$added_jump=0;
		foreach $sat ( @sats ) {
		for $i (1..$freq_num{$sat}) {

	if ($p0{$sta." ".$sat." ".$i}) {
$jump_p=abs($p{$sta." ".$sat." ".$i}-$p0{$sta." ".$sat." ".$i});
$jump_l=abs($l{$sta." ".$sat." ".$i}-$l0{$sta." ".$sat." ".$i});
$max_leap++;
###print $t0,$max_leap,$n_leaps,$jump_p,$jump_l,$p{$sat." ".$i},$p0{$sat." ".$i};
if ($jump_l>0.0009*$c_light && $jump_p<0.0001*$c_light) {
$n_leaps++;
$added_jump+=1000*($l{$sta." ".$sat." ".$i}-$l0{$sta." ".$sat." ".$i})/$c_light;


                                                         }
                               }

              		                     }

                 		       }

if ($n_leaps>4 && $n_leaps==$max_leap) {

     if ($added_jump>0) {
$leap{$sta}+=int($added_jump/$n_leaps+0.5)*$c_light*0.001;
                        } else {
$leap{$sta}+=int($added_jump/$n_leaps-0.5)*$c_light*0.001;
                               }
print (F2 "leapms at ",$t0,$sta,$d[2],$leap{$sta});
                                       }
for $i (1..$line) {
@b=split(' ',$all_line[$i],22);
$f_num=length($b[5])-1;
for $j (1..$f_num) {$b[6+$j]+=-1*$leap{$sta}}
if ($f_num eq 2) {
printf "%2d %3d %6d %4s %4s  %2d %16.4f %16.4f %14.4f %14.4f %3d %2d %2d %8d %1d\n",@b;
                 }
if ($f_num eq 3) {
printf "%2d %3d %6d %4s %4s  %2d %16.4f %16.4f %16.4f %14.4f %14.4f %14.4f %3d %2d %2d %2d %14.4f %14.4f %14.4f \n",@b;
                 }
                  }

### restart the arrays
$line=1;
@all_line=();
$all_line[1]=$_;
foreach $key ( keys %p ) {
$p0{$key}=$p{$key};
$l0{$key}=$l{$key};
                         }

%l=();%p=();@sats=();%freq_num=();
$sat=$d[5]." ".$d[6];
$sta=$d[4];
$freq_num{$sat}=length($d[5])-1;
push(@sats,$sat);
for $i (1..$freq_num{$sat})   {
$l{$sta." ".$sat." ".$i}=$d[6+$i];
$p{$sta." ".$sat." ".$i}=$d[6+$freq_num{$sat}+$i];
                        }
label0:
$t0=$d[3];

            }
