c234567
c This program computes, from an observation file, the GNSS position through
c the pseudorange method. 
c 
c The program also computes the rough receiver position
c (epoch by epoch) applying the Bancroft method, this is useful for moving 
c receivers. 
c
c Additionally, some initial corrections depending on receiver-satellite 
c position are also computed.


       implicit double precision (a-h,o-z)
       parameter (N_GNSS=500,N_LINES=800)
       dimension nsat(N_GNSS),gnss_times(N_GNSS,N_LINES),
     * gnss_x(N_GNSS,N_LINES),gnss_y(N_GNSS,N_LINES),
     * gnss_z(N_GNSS,N_LINES),gnss_clock(N_GNSS,N_LINES),
     * gnss_vx(N_GNSS,N_LINES),gnss_vy(N_GNSS,N_LINES),
     * gnss_vz(N_GNSS,N_LINES),time_(N_LINES),t_(10),x_(10),
     * z_(10),y_(10),r_sat(3),v_sat(3),sta_sat(3),
     * first_time(N_GNSS),f_(8),r_sta(3),sat_antenna(3),
     * xlast_time(N_GNSS),ifreq(5),pc_sat(N_GNSS,3),
     * yaw0i(200,200,1400),yaw0j(200,200,1400),eclipse_time(N_GNSS),
     * wk1(3),wk2(3),wk3(3),pc_val(N_GNSS,25),d_pc(N_GNSS),
     * n_pc_levels(N_GNSS),wk0(100),r_sta0(N_GNSS,3),trop0(N_GNSS),
     * ista_sat_arc(200,200)

        character*4 sta_name(N_GNSS),sta,a4,b4
        character*1 a1,gnss_type
        character*7 header
        character*160 a160

        logical sta_coor_present,eclipse_sat

          common /windup_/yaw0i,yaw0j,sta_sat,ista,isat,iarc


c     SOME INITIAL PARAMETERS cccccccccccccc
           ndeg=10
           c=299792.458d0
           xmu=3.986005d14*1d-9
           omega=7.2921151d-5
           g2r=datan2(1.d0,1.d0)/45.d0
          do i=1,N_GNSS
           nsat(i)=0
           eclipse_time(i)=-1.d8
          enddo
cccccc GNSS frequencies
c       DATA (f_(i),i=1,8) /1575.42d6, 1227.60d6,0.d0,0.d0, 1176.45d6,
c         1278.75d6, 1207.140d6,1191.795d6/
cccccccccccccccccccccccccccccccccccccccccccccc
c PARALLEL (Intel does not like DATA

             f_(1)=1575.42d6
             f_(2)=1227.60d6
             f_(3)=0000.00d0
             f_(4)=0000.00d0
             f_(5)=1176.45d6
             f_(6)=1278.75d6
             f_(7)=1207.14d6
             f_(8)=1191.795d6



            sta_coor_present = .false.
            isec00=-999
            iline=0
            ndata=0

             do i=1,200
              do j=1,200
                ista_sat_arc(i,j)=-200
              enddo
             enddo

cccccccccccccccccccccccccccccccccccccccccccccc

c   Reading the GNSS satellite position and clock in order to interpolate
c   to the transmission time

         open (unit=10,file="orbit_gnss.dat")
     

         read (10,*,end=999) header,iyy,idoy0

10       read (10,*,end=999) xxb,gnss_type,isat,yyb1,yyb2,yyb3,
     * vyyb1,vyyb2,vyyb3,yyt0

        if (gnss_type .eq. "E") isat=isat+40
        if (gnss_type .eq. "C") isat=isat+80
        if (gnss_type .eq. "J") isat=isat+120

          nsat(isat)=nsat(isat)+1

           i=nsat(isat)
         gnss_times(isat,i)=xxb
         gnss_x(isat,i)=yyb1
         gnss_y(isat,i)=yyb2
         gnss_z(isat,i)=yyb3
         gnss_clock(isat,i)=yyt0
         gnss_vx(isat,i)=vyyb1
         gnss_vy(isat,i)=vyyb2
         gnss_vz(isat,i)=vyyb3
c        if (nsat(isat) .eq. 1) first_time(isat)=xxb
c        xlast_time(isat)=xxb
         goto 10

999      continue
           close (10)

          do i=1,N_GNSS          
           first_time(i)=gnss_times(i,5)
           if (nsat(i) .gt. 6)
     *      xlast_time(i)=gnss_times(i,nsat(i)-5)
          enddo

ccccccccccccccccccccccccccccccccccccccc 
cccccc READING THE GNSS PHASE CENTERS
        yyyy=dfloat(iyy+2000)+dfloat(idoy0)/365.25d0
        if (yyyy .gt. 2050.) yyyy=yyyy-100.d0

                             if (yyyy .ge. 2006.846) then

        open (unit=4,file=
     * '../info_files/igs_pc_sat_new.dat')
c80       read (4,'(i2,1x,f7.3,2x,f7.3,1x,a1,1x,a7,1x,
c     *3(1x,f7.4))',end=81)
80     read(4,*,end=81) 
     *isat,yy0,yy1,a1,header,pc1,pc2,pc3,pc4,pc5,pc6,ipc,
     * (wk0(j),j=1,ipc)
        if (yyyy .ge. yy0 .and. yyyy .lt. yy1) then
         if (a1 .eq. "E") isat=isat+40
         if (a1 .eq. "C") isat=isat+80
         if (a1 .eq. "J") isat=isat+120
         pc_sat(isat,1)=pc1
         pc_sat(isat,2)=pc2
         pc_sat(isat,3)=pc3
         n_pc_levels(isat)=ipc
         d_pc(isat)=pc6
           do j=1,ipc
            pc_val(isat,j)=wk0(j)
           enddo
        endif
        goto 80
                               else

        open (unit=4,file=
     * '../info_files/igs_pc_sat_old.dat')
82       read (4,'(i2,2x,f7.3,2x,f7.3,1x,a4,1x,3(1x,f7.4))',
     *        end=81)
     *isat,yy0,yy1,b4,pc1,pc2,pc3
        if (yyyy .ge. yy0 .and. yyyy .lt. yy1) then
         if (b4(1:1) .eq. "E") isat=isat+40
         if (b4(1:1) .eq. "C") isat=isat+80
         if (b4(1:1) .eq. "J") isat=isat+120
         pc_sat(isat,1)=pc1
         pc_sat(isat,2)=pc2
         pc_sat(isat,3)=pc3
        endif
        goto 82

                               endif

81      continue

             n_sta=0
             open (unit=4,file="sta.coor")
70         read(4,*,end=71) b4,xr,xlo,xla,trop
              n_sta=n_sta+1
              sta_name(n_sta)=b4
              r_sta0(n_sta,1)=xr*dcos(xla*g2r)*dcos(xlo*g2r)*1.d-3
              r_sta0(n_sta,2)=xr*dcos(xla*g2r)*dsin(xlo*g2r)*1.d-3
              r_sta0(n_sta,3)=xr*dsin(xla*g2r)*1.d-3
              trop0(n_sta)=trop
            goto 70
71         continue

            open (unit=43,file="yaw.dat")
180         read(43,*,end=181)i,j,k,yyii,yyjj 
            yaw0i(i,j,k)=yyii
            yaw0j(i,j,k)=yyjj
            goto 180
181         continue
            close (43)
ccccccccccccccccccccccccccccccccccccccc
cc   Computing the sidereal time for the first epoch in the orbit file.

            fday=0.d0
            dj=365.d0*(iyy)+(iyy-1)/4+idoy0+fday-0.5d0
            if (iyy*1 .lt. 20) dj=dj+365.d2+25.
            t=dj/36525.d0
          gst0=67310.54841+8640184.812866*t+0.093104*t**2
     * -6.2d-6*t**3

          gst0=dmod(gst0*15.d0/3600.d0+720.d0+180.d0,360.d0)


ccccccccccccccccccicccccccccccccccc

cccccccccccccccccccccccccccc
          open(unit=3,file="eclipse.log")
          open(unit=13,file="model.log")

ccccccccccccccccccccccccccc


20         read (*,'(a160)',end=998) a160
30         read (a160,*) iyear,idoy,ssec,sta,a4


c  This for identify GNSS system and freq. number.
           ifreq_num=0
           do i=1,4
           read (a4(i:i),'(a1)') a1
           if (i .eq. 1) gnss_type=a1
           if (i .gt. 1 .and. a1 .ne. " ") then
             ifreq_num=ifreq_num+1
             read (a1,*) ifreq(ifreq_num)
           endif
           enddo

cccccc Achieve the RCV position in km

           do ista=1,n_sta
            if (sta_name(ista) .eq. sta) then
              do j=1,3
               r_sta(j)=r_sta0(ista,j)
              enddo
               trop=trop0(ista)
              goto 73
            endif
           enddo

73         continue
           ndata=ndata+1
cccccccccccccccccccccccccccccccccccccc

       if (ifreq_num .eq. 2) then
           read (a160,*,end=998) iyear,idoy,sec0,sta,a4,isat,xl1,xl2,
     * xp1,xp2,iarc,isnr1,isnr2
       endif
       if (ifreq_num .eq. 3) then
           read (a160,*,end=998) iyear,idoy,sec0,sta,a4,isat,xl1,xl2,
     * xl3,xp1,xp2,xp3,iarc,isnr1,isnr2,isnr3
       endif

c         print *,iyear,idoy,sec0,sta,a4,isat

         ista_sat_arc(ista,isat)=iarc
         isec0 = nint(sec0)
         if (ndata .eq. 1) isec00=isec0

         sec=sec0+dfloat(idoy-idoy0)*86400.d0

         if (gnss_type .eq. "E") isat=isat+40
         if (gnss_type .eq. "C") isat=isat+80
         if (gnss_type .eq. "J") isat=isat+120

          if (sec .lt. first_time(isat)+1. .or. sec .gt. 
     * xlast_time(isat)-1.) then
c      print *,"time outside the GNSS time range",sec,first_time(isat),
c    *  xlast_time(isat)-1.
            goto 995
         endif

cccccccccccccccccccccccccccc

c        if (isec0 .ne. isec00) then
c        close(44)
c        open (unit=44,file="yaw.dat")
c        endif

cccccccccccc GNSS position

          do i=1,N_LINES
           time_(i)=gnss_times(isat,i)
          enddo
          call locate(time_,nsat(isat),sec,j)

          nndeg=int(ndeg/2)

                   do i=0,ndeg-1
          t_(i+1)=time_(j-nndeg+1+i)
          x_(i+1)=gnss_x(isat,j-nndeg+1+i)
          y_(i+1)=gnss_y(isat,j-nndeg+1+i)
          z_(i+1)=gnss_z(isat,j-nndeg+1+i)
                    enddo

ccccc Computes the transmission time by using the GNSS clock (dt_sat)
       dt_sat=gnss_clock(isat,j)+
     * (sec-time_(j))*(gnss_clock(isat,j+1)-gnss_clock(isat,j))
     * /(time_(j+1)-time_(j))


           tr_time=sec-xp1*1.d-3/c-dt_sat/c
cccccccccccccccccc


         call polint(t_,x_,ndeg,tr_time,r_sat(1),dy1)
         call polint(t_,y_,ndeg,tr_time,r_sat(2),dy2)
         call polint(t_,z_,ndeg,tr_time,r_sat(3),dy3)
         call polint(t_,x_,ndeg,tr_time+0.001,v_sat(1),dy1)
         call polint(t_,y_,ndeg,tr_time+0.001,v_sat(2),dy2)
         call polint(t_,z_,ndeg,tr_time+0.001,v_sat(3),dy3)

          do i=1,3
           v_sat(i)=(v_sat(i)-r_sat(i))*1.d3
          enddo
cccccccccccccccccccccc
ccc Converts the Reference frame to Earth Fixed RF at the reception time
         do iter=1,2
         do i=1,3
          sta_sat(i)=r_sat(i)-r_sta(i)
         enddo
          call esc_prod(sta_sat,sta_sat,rho)

          rho=dsqrt(rho)

           
          angle=omega*rho/c/g2r
c          print *,"SAT ",sec,j,isat,r_sat,dt_sat
         if (iter .eq. 1) then
          call rot3(angle,r_sat)
          call rot3(angle,v_sat)
         endif
c          write (*,'(a5,1x,f6.0,1x,i3,i3,4(f14.6,1x))') 
c    *  "SAT2 ",sec,j,isat,(r_sat(i),i=1,3),dt_sat
         enddo

          
ccccccccccccccccccccccEND OF SATELLITE POSITION
            call esc_prod(r_sat,r_sat,r_sat_mod)
            call esc_prod(r_sta,r_sta,r_sta_mod)
            call esc_prod(r_sat,v_sat,r_v_sat)
            r_sat_mod=dsqrt(r_sat_mod)
            r_sta_mod=dsqrt(r_sta_mod)


           

cccccccc Computes the along and cross track components

          gst=(gst0+sec*15.d0*366.25/3600./365.25)
           do j=1,3
            wk1(j)=v_sat(j)
           enddo

ccccc velocity is corrected from the Earth rotation
           wk1(1)=wk1(1)-omega*r_sat(2)
           wk1(2)=wk1(2)+omega*r_sat(1)

ccccc   The angular momentum vector (wk2)
           call vec_prod(r_sat,wk1,wk2)

            call normalise(wk2)

cccccc this is only to test the constant value of the angular momentum
ccccc in an intertial system
c           call rot3(-1.d0*gst,wk2)
c           print *,"WK ",sec_fix,isat,wk2,gst

cccccc the transverse vector (wk1)
           call vec_prod(wk2,r_sat,wk1)
           call normalise(wk1)
           call esc_prod(sta_sat,wk1,along)
           call esc_prod(sta_sat,wk2,cross)
           call esc_prod(sta_sat,r_sat,radial)
           along=along/rho
           cross=cross/rho
           radial=radial/rho/r_sat_mod

cccccccccccccccccc Relativistic corrections ccccc


            rel_cor_g=2.d0*xmu*log((r_sta_mod+r_sat_mod+rho)/
     * (r_sta_mod+r_sat_mod-rho))/c**3
            rel_cor_c=2.d0*r_v_sat/c

c           print *,rel_cor_c,rel_cor_g 
            

cccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccc Tropospheric corrections

        call xyz2elip(r_sta,xxh,xlone,xlate)
        wk1(1)=dcos(xlate)*dcos(xlone)
        wk1(2)=dcos(xlate)*dsin(xlone)
        wk1(3)=dsin(xlate)


        call esc_prod(sta_sat,wk1,elev)
        elev=elev/rho
        elev=atan2(elev,dsqrt(1-elev**2))/g2r

         tdoy=dfloat(idoy)+sec0/86400.d0

        
        call sub_trop_niell(tdoy,xlate,xxh*1.d3,elev,
     *  xm_hydr,xm_wet)


        trop_cor=(xm_hydr*trop+xm_wet*0.1)*1.d-3


ccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccc GNSS phase center correction and eclipsed satellite

       call gsdtime_sun(dfloat(iyear),idoy,
     * sec0,gstr,slong,sra,sdec)

         solar_long=sra-gstr
       wk1(1)=dcos(sdec*g2r)*dcos(solar_long*g2r)*1.4959d8-r_sat(1)
       wk1(2)=dcos(sdec*g2r)*dsin(solar_long*g2r)*1.4959d8-r_sat(2)
       wk1(3)=dsin(sdec*g2r)*1.4959d8-r_sat(3)

        call normalise(wk1)

ccc Body-fix reference frame X(wk1), Y(wk2), Z(-r_sat/r_sat_mod)
ccc

        call vec_prod(wk1,r_sat,wk2)
        call vec_prod(r_sat,wk2,wk1)
    
         call normalise(wk1)
         call normalise(wk2)

          do ii=1,3
        sat_antenna(ii)=-1.d0*(pc_sat(isat,1)*wk1(ii)+
     * pc_sat(isat,2)*wk2(ii)-
     * pc_sat(isat,3)*r_sat(ii)/r_sat_mod)*1.d-3
          enddo

        call esc_prod(sat_antenna,sta_sat,pcenter_cor)
        pcenter_cor=pcenter_cor/rho

c       print *,"PCEMTER ",pcenter_cor

cccccccccccccccccccccWIND UP
ccccc yaw angle in radians

        call windup(wk1,wk2,xlone,xlate,yaw)
c       print *,"WIND ",sec0,yaw

cccccccccccccccccccccccccccccccccccccccccccc


c        write (*,'(a8,1x,i7,1x,f14.3,3(1x,f14.3))')
c    * "SAT_POS ",nint(sec0),xp1+dt_sat*1.d3,
c    * (r_sat(ii)*1.d3,ii=1,3)

         call normalise(sta_sat)

         write (13,'(a8,2(1x,i7),1x,i2,2(1x,f14.3),5(1x,f14.9))')
     * "SAT_POS ",idoy,nint(sec0),isat,
     * (f_(1)**2*xp1-f_(2)**2*xp2)/(f_(1)**2-f_(2)**2)+
     * dt_sat*1.d3-rho*1.d3,
     * (f_(1)**2*xl1-f_(2)**2*xl2)/(f_(1)**2-f_(2)**2)+
     * dt_sat*1.d3-rho*1.d3,
     * (sta_sat(ii),ii=1,3),1.d0,yaw


cccccccccccccccccccccccccSatellite antenna CAL cc

       if (yyyy .ge. 2006.846) then
        sat_zen=dacos((-1.d0*r_sta_mod**2+r_sat_mod**2+rho**2)/
     * 2.d0/r_sat_mod/rho)/g2r

       izen0=int(sat_zen/d_pc(isat))+1

      sat_cal=pc_val(isat,izen0)+(sat_zen-(izen0-1)*d_pc(isat))*
     *  (pc_val(isat,izen0+1)-pc_val(isat,izen0))/d_pc(isat)

       else
        sat_cal=0.d0

       endif

ccccccccccccccccccccccccccccccccccccccccccccccccccc

cccccc  results are output in meters
c         xl1=xl1+dt_sat*1.d3
c         xl2=xl2+dt_sat*1.d3
c         xp1=xp1+dt_sat*1.d3
c         xp2=xp2+dt_sat*1.d3

          if (.not. eclipse_sat .and. xm_wet .lt. 10) then

         if (ifreq_num .eq. 2) then

         write (*,'(i2,1x,i3,i7,1x,a4,1x,a4,i3,
     * 4(1x,f15.4),i5,i4,i4,4(1x,f11.8),1x,f14.4,4(1x,f8.4),
     * 3(1x,f11.8),1x,f5.2)')
     *   iyear,idoy,nint(sec0),sta,a4,isat,xl1,xl2,
     * xp1,xp2,iarc,isnr1,isnr2,
     * (sta_sat(i),i=1,3),xm_wet,
     * rho*1.d3,(rel_cor_c+rel_cor_g*c)*1.d3,
     * trop_cor*1.d3,pcenter_cor*1.d3-sat_cal,yaw,along,cross,radial,
     * elev/g2r

        endif

         if (ifreq_num .eq. 3) then
c        xl3=xl3+dt_sat*1.d3
c        xp3=xp3+dt_sat*1.d3

         write (*,'(i2,1x,i3,f7.0,1x,a4,1x,a4,i3,
     * 6(1x,f15.4),i5,i4,i4,i4,4(1x,f11.8),
     * 1x,f14.4,4(1x,f8.4),3(1x,f11.8),1x,f5.2)')
     *   iyear,idoy,sec0,sta,a4,isat,xl1,xl2,xl3,
     * xp1,xp2,xp3,iarc,isnr1,isnr2,isnr3,
     * (sta_sat(i),i=1,3),xm_wet,rho*1.d3,
     * (rel_cor_c+rel_cor_g)*1.d3,
     * trop_cor*1.d3,pcenter_cor*1.d3,yaw,
     * along,cross,radial,elev/g2r

        endif


       isec00=isec0
cccccccccccccccc if no eclipse_Sat
         call f77flush()
         endif

995    continue

         goto 20

998      continue

         open (unit=44,file="yaw.dat")

         do i=1,n_sta
          do j=1,100
           if (ista_sat_arc(i,j) .gt. 0) then
            iarc=ista_sat_arc(i,j)
            write(44,*) i,j,iarc,yaw0i(i,j,iarc),
     *        yaw0j(i,j,iarc)
           endif
          enddo
         enddo

         call f77flush()
         close(44)


         end

      SUBROUTINE locate(xx,n,x,j)
      implicit double precision (a-h,o-z)
      INTEGER j,n
      double precision x,xx(800)
      INTEGER jl,jm,ju
      jl=0
      ju=n+1
10    if(ju-jl.gt.1)then
        jm=(ju+jl)/2
c        print *,xx(n),xx(1),x,xx(jm),xx(n),jl,jm,ju
        if((xx(n).gt.xx(1)).eqv.(x.gt.xx(jm)))then
          jl=jm
        else
          ju=jm
        endif
c       print *,jl,ju,jm,xx(n),xx(1),x,ju-jl
      goto 10
      endif
      j=jl
      return
      END


      SUBROUTINE polint(xa,ya,n,x,y,dy)
      implicit double precision (a-h,o-z)
      INTEGER n,NMAX
      double precision dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=20)
      INTEGER i,m,ns
      double precision den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=dabs(x-xa(1))
      do 11 i=1,n
        dift=dabs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp

          if(den.eq.0.) then
c           pause 'faillllure in polint two equal times'
            y=0.d0
            return
          endif
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      END

        subroutine rot3(ang0,r)
        implicit double precision (a-h,o-z)
        dimension r(3),rp(3)
        g2r=datan2(1.d0,1.d0)/45.d0
         ang=ang0*g2r
        rp(1)=dcos(ang)*r(1)+dsin(ang)*r(2)
        rp(2)=-dsin(ang)*r(1)+dcos(ang)*r(2)
        rp(3)=r(3)
        do i=1,3
         r(i)=rp(i)
        enddo

        return
        end



        subroutine rot2(ang0,r)
        implicit double precision (a-h,o-z)
        dimension r(3),rp(3)

        g2r=datan2(1.d0,1.d0)/45.d0
        ang=ang0*g2r
        rp(1)=dcos(ang)*r(1)-dsin(ang)*r(3)
        rp(2)=r(2)
        rp(3)=dsin(ang)*r(1)+dcos(ang)*r(3)
        do i=1,3
         r(i)=rp(i)
        enddo

        return
        end

         subroutine vec_prod(r1,r2,r3)
          implicit double precision (a-h,o-z)
          dimension r1(3),r2(3),r3(3)
            r3(1)=r1(2)*r2(3)-r1(3)*r2(2)
            r3(2)=r1(3)*r2(1)-r1(1)*r2(3)
            r3(3)=r1(1)*r2(2)-r1(2)*r2(1)


          return
          end

          subroutine esc_prod(r1,r2,r12)
          implicit double precision (a-h,o-z)
          dimension r1(3),r2(3)

           r12=0.d0

           do ii=1,3
            r12=r12+r1(ii)*r2(ii)
           enddo

          return
          end


        subroutine xyz2elip(r_sta,h_el,xlon,xlat)

ccccccccc This subroutine transform cartesian coordinates WGS84 to 
ccccccccc Elipsoidal coordinates
        implicit double precision (a-h,o-z)
        dimension r_sta(3)


        a_axis=6378137.d-3
        b_axis=6356752.314d-3
        excen=sqrt(1.d0-b_axis**2/a_axis**2)
        eps=100.d0

        xlon=datan2(r_sta(2),r_sta(1))
        xlat=datan2(r_sta(3),dsqrt(r_sta(1)**2+r_sta(2)**2))

1010     continue
         if (dabs(eps) .lt. 1.d-14) goto 1020
          rho_el=a_axis/dsqrt(1-excen**2*(dsin(xlat))**2)
          h_el=dsqrt(r_sta(1)**2+r_sta(2)**2)/dcos(xlat)-rho_el
          xx_el=1.d0/(1.d0-excen**2*rho_el/(rho_el+h_el))
          xlat=datan2(r_sta(3)*xx_el,dsqrt(r_sta(1)**2+r_sta(2)**2))
          eps=xlat-xlat0
          xlat0=xlat


         goto 1010

1020     continue 
         return
         end

        subroutine sub_trop_niell(doy,xlatt,H,elv,xm_hydr,xm_wet)
        implicit double precision (a-h,o-z)
        dimension avr(3,5),amp(3,5),awt(3,5)

        pi=datan2(1.d0,1.d0)*4.d0
        elv=elv*pi/180.d0

        xlat=dabs(xlatt)*180.d0/pi

c   ---Coefficients of Hydrstatic Mapping Function (nmfh2.0)---

c       ........................Average.......................
        data (avr(1,j),j=1,5) /
     :  1.2769934d-3, 1.2683230d-3, 1.2465397d-3, 1.2196049d-3,
     :  1.2045996d-3 /
        data (avr(2,j),j=1,5) /
     :  2.9153695d-3, 2.9152299d-3, 2.9288445d-3, 2.9022565d-3,
     :  2.9024912d-3 /
        data (avr(3,j),j=1,5) /
     :  62.610505d-3, 62.837393d-3, 63.721774d-3, 63.824265d-3,
     :  64.258455d-3 /
c       .......................................................

c       .......................Amplitude.......................
        data (amp(1,j),j=1,5) /
     :  0.d0,         1.2709626d-5, 2.6523662d-5, 3.4000452d-5,
     :  4.1202191d-5 /
        data (amp(2,j),j=1,5) /
     :  0.d0,         2.1414979d-5, 3.0160779d-5, 7.2562722d-5,
     :  11.723375d-5 /
        data (amp(3,j),j=1,5) /
     :  0.d0,         9.0128400d-5, 4.3497037d-5, 84.795348d-5,
     :  170.37206d-5 /
c       .......................................................

c       ....................Height Correction .................
        data aht / 2.53d-5 /
        data bht / 5.49d-3 /
        data cht / 1.14d-3 /
c       .......................................................
c   -------------------------------------------------------------
c   ---Coefficients of Wet Mapping Function (nmfw2.0)------------
        data (awt(1,j),j=1,5) /
     :  5.8021897d-4, 5.6794847d-4, 5.8118019d-4, 5.9727542d-4,
     :  6.1641693d-4 /
        data (awt(2,j),j=1,5) /
     :  1.4275268d-3, 1.5138625d-3, 1.4572752d-3, 1.5007428d-3,
     :  1.7599082d-3 /
        data (awt(3,j),j=1,5) /
     :  4.3472961d-2, 4.6729510d-2, 4.3908931d-2, 4.4626982d-2,
     :  5.4736038d-2 /

c   -------------------------------------------------------------

c   ---MAPPING FUNCTIONS-----------------------------------------

c       ...Hidrostatic mapping ..................................
c       +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c       WARNING:[There is a error of sign ("+==>-") in the paper]
c       +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        a=xinterp(xlat,avr,1)-
     *    xinterp(xlat,amp,1)*dcos(2.d0*pi*(doy-28.d0)/365.25d0)

        b=xinterp(xlat,avr,2)-
     *    xinterp(xlat,amp,2)*dcos(2.d0*pi*(doy-28.d0)/365.25d0)

        c=xinterp(xlat,avr,3)-
     *    xinterp(xlat,amp,3)*dcos(2.d0*pi*(doy-28.d0)/365.25d0)
        xm_hydr=xm(elv,a,b,c)+
     *     (1.d0/dsin(elv)-xm(elv,aht,bht,cht))*H/1000.d0

c       ........................................................

c       ...Wet mapping .........................................
        a=xinterp(xlat,awt,1)
        b=xinterp(xlat,awt,2)
        c=xinterp(xlat,awt,3)
c       print *, a,b,c

        xm_wet=xm(elv,a,b,c)
c       ........................................................

c     print *, "xm_hydr,xm_wet", xm_hydr,xm_wet,elv,xlatt
c   --------------------------------------------------------------

       return
       end


        double precision function xinterp(x,v,i)
        implicit none
        double precision x,x1,y1,x2,y2,v(3,5)
        integer i,j

c        print *,x

        if (x.le.15.d0) then
           xinterp=v(i,1)
           goto 100
        endif
        if (x.ge.75.d0) then
           xinterp=v(i,5)
           goto 100
        endif

        j=1+int(x/15.d0-1)

        x1=15.d0*dble(j)
        y1=v(i,j)
        x2=15.d0*dble(j+1)
        y2=v(i,j+1)

        xinterp=(x-x2)/(x1-x2)*y1+(x-x1)/(x2-x1)*y2
c        print *,x1,x2,y1,y2
100     continue
        end
c   --------------------------------------------------------------
        double precision function xm(elv,a,b,c)
        implicit none
        double precision elv,a,b,c,xn,xd
c       +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c       WARNING: ther is a error in the mapping formula i the paper
c       +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        xn=1.d0+a/(1.d0+b/(1.d0+c))
        xd=dsin(elv)+a/(dsin(elv)+b/(dsin(elv)+c))

        xm=xn/xd

        end
c   --------------------------------------------------------------

        subroutine gsdtime_sun(year,iday,sec,gstr,slong,sra,sdec)
       implicit double precision (a-h,o-z)
         data rad/57.29578/
         fday = sec/86400.d0
         if (year .lt. 80 ) year=year+2000.
         if (year .gt. 1900) year=year-1900.
         dj=365.d0*(year)+int((year-1)/4)+dfloat(iday)+fday-0.5d0
         t=dj/36525.d0
          vl=dmod(279.696678+0.9856473354*dj,360.d0)
         gstr=dmod(279.690983d0+0.9856473354d0*dj+360.d0*fday+
     * 180.d0,360.d0)
          g=dmod(358.475845+0.985600267*dj,360.d0)/rad
           slong=vl+(1.91946-0.004789*t)*sin(g)+0.020094*sin(2*g)
         obliq=(23.45229-0.0130125*t)/rad
         slp=(slong-0.005686)/rad
         sind=sin(obliq)*sin(slp)
         cosd=sqrt(1.-sind**2)
          sdec=rad*atan(sind/cosd)
          sra=180.-rad*atan2(sind/cosd/tan(obliq),-cos(slp)/cosd)
c        print *,year,iday,' a ',sec,gstr,fday,dj,sra,sdec,t,'sol'
        return
        end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       subroutine windup(rb,rj,xlon_st,xlat_st,yaw)

ccccccccccccccccccccccccccccccccccccc
c This subroutine computes the windup for both satellite and receiver
ccccccccccccccccccccccccccccccccccccccccc

        implicit double precision(a-h,o-z)
          dimension rb(3),rj(3),xk(3),sty(3),stz(3),wk(3),
     *    yaw0i(200,200,1400),yaw0j(200,200,1400),r_fix(200,3,3),
     *   wk2(3),sta_sat(3)

          character*4 sta
       
          common /windup_/yaw0i,yaw0j,sta_sat,ista,isat,iarc

          g2r=datan2(1.d0,1.d0)/45.d0
          pi=datan2(1.d0,1.d0)*4.d0

           sty(1)=0.d0
           sty(2)=1.d0
           sty(3)=0.d0

           call rot3(-xlon_st/g2r,sty)

           stz(1)=dcos(xlat_st)*dcos(xlon_st)
           stz(2)=dcos(xlat_st)*dsin(xlon_st)
           stz(3)=dsin(xlat_st)

            do ii=1,3
            xk(ii)=-1.d0*sta_sat(ii)
            enddo

           call normalise(xk)

           call vec_prod(stz,xk,wk)
          call esc_prod(wk,sty,y_k)

c          wk2 direccion x

           call vec_prod(sty,stz,wk2)
           call esc_prod(wk,wk2,x_k)
           call esc_prod(wk,wk,z_k_mod)


           phi=datan2(x_k,-1.d0*y_k)

              y_k0=z_k_mod

           call esc_prod(rj,rj,rj_mod)

           call vec_prod(rb,rj,wk2)
           call vec_prod(xk,wk2,wk)

           call esc_prod(wk,rj,y_k)
           call esc_prod(wk,wk,z_k_mod)

           call esc_prod(wk,rb,x_k)

           call esc_prod(rb,rb,rb_mod)

          phip=datan2(x_k/dsqrt(rb_mod),-y_k/dsqrt(rj_mod))

c          print *,' B ',sec,isat,x_k,y_k

ccccccccccccccccccccc
           dphip=phip-yaw0j(ista,isat,iarc)
           dphi=phi-yaw0i(ista,isat,iarc)

             if (yaw0i(ista,isat,iarc) .lt. -900.) then
           phi=dmod(phi+3*pi,2*pi)-pi
           phip=dmod(phip+3*pi,2*pi)-pi
             else
             phi=yaw0i(ista,isat,iarc)+datan2(dsin(dphi),dcos(dphi))
            phip=yaw0j(ista,isat,iarc)+datan2(dsin(dphip),dcos(dphip))
            endif
ccccccccccccccccccccccccccccccccc

            yaw=phi+phip

            yaw0i(ista,isat,iarc)=phi
            yaw0j(ista,isat,iarc)=phip



3010       continue
           return
           end
cccccccccccccccccccccccccccccccccccccccccccccccc

       subroutine normalise(r1)
         implicit double precision (a-h,o-z)
          dimension r1(3)

           r12=0.d0

           do ii=1,3
            r12=r12+r1(ii)*r1(ii)
           enddo

           do ii=1,3
            r1(ii)=r1(ii)/dsqrt(r12)
           enddo

          return
          end

