#!/usr/bin/perl

$,=" ";
$[=1;
$\="\n";


#####################################################################################
## This spcript reads from STINPUT and apply the correcctions computed by the		#
## model programa. Inside this script the antenna phase center of the 				#
## rcv  (read_antenna_pc.pl) is ##compued among the tides corrections 				#
## (compute_tides.pl)																#
##																					#
## This script shall be applied only to actual data, there is an equivalent one		#
## for simulated data.																#
#####################################################################################i


####
##################CONSTANTS
$c_light=299792458;
$f0=10.23e6;
$f[1]=1575.42e6;
$f[2]=1227.60e6;
$f[5]=1176.45e6;
$f[6]=1278.75e6;
$f[7]=1207.140e6;
$f[8]=1191.795e6;

$dt_tides=300;
##############

open (F10,">> antenna.log");

while (<>) {
chop;
@d=split(' ',$_,44);
$ndata++;
### Indentify sta,year and doy for computing tides and pc

	if ($ndata==1) {
	$doy0=$d[2];
      if (($d[1] < 80 && $d[1]>6) || ($d[1]==6 && $d[2]>=309)) {
    `../../prefits_bin/read_antenna_pc.pl $d[4]`;
           $week_1400=1;
                                                               } else {
         `../../prefits_bin/read_antenna_pc_before_w1400.pl $d[4]`;
           $week_1400=0;
                                                                      }
    `../../prefits_bin/compute_tides.pl $d[4] $d[1] $d[2] $dt_tides`;

	open (F1,"antenna.dat");

		while (<F1>) {
		chop;
		@c=split(' ',$_,29);
		for $j (1..3) {$pc{$c[1]." ".$j}=$c[$j+1]};

                  if ($week_1400==1) {
                $n_levels=int(($c[6]-$c[5])/$c[7]+0.5)+1;
                $d_elev[$c[1]]=$c[7];
                for $j (1..$n_levels) { $ant_cal{$c[1]." ".$j}=$c[$j+7]}
                                     } else {

                                            }
             		     }

        open (F1,"tides.dat");

                while (<F1>) {
                chop;
                @c=split(' ',$_,8);
                for $j (1..3) {$tide0{$c[1]." ".$j}=$c[$j+1]+$c[$j+4]};
                             }


$file_out = "tmp.prefits";
open (F2,"> $file_out");
#### if ($ndata==1
                      }

################# END of building tide and antenna pc corrections

################# START RESIDUAL COMPUTATION
### computing the tide correcction through a linear interpolation#####
$t=($d[2]-$doy0)*86400+$d[3];
@p=();
@l=();
$t_tide0=int($t/$dt_tides)*$dt_tides;
for $i (1..3) {
$tide[$i]=$tide0{$t_tide0." ".$i}+($t-$t_tide0)*($tide0{eval($t_tide0+$dt_tides)." ".$i}-$tide0{$t_tide0." ".$i})/$dt_tides;
              }

#####################################################################

$freq_num=length($d[5])-1;
$gnss_type=substr($d[5],1,1);
for $j (1..$freq_num) {$f_[$j]=substr($d[5],$j+1,1)}

if ($freq_num==2) {
#### relativistic,tropospheric and sat_pc
$corr1=$d[19]+$d[20]-$d[21];
#### tides
$tide_corr=0;
for $j (1..3) {$tide_corr += $d[13+$j]*$tide[$j]}

### windup and sta_pc
for $i (1..$freq_num) {

$ii=$f_[$i]; 
$windup[$i]=$d[22]*$c_light/$f[$ii]/4/atan2(1,0);;

##### Antenna Calibration Value
$ant_cal_value=0;
#

$i_cal=$f_[$i];
if ($week_1400==1) {
##$i_cal=$f_[$i];
$change_cal=0;


if ($d_elev[$i_cal]*1==0 && ($i_cal==7 || $i_cal==8 || $i_cal==5)) {
if ($d_elev[5]>0) {$i_cal=5;$change_cal=1}
if ($d_elev[7]>0) {$i_cal=7;$change_cal=1}
if ($d_elev[8]>0) {$i_cal=8;$change_cal=1}
if ($n_log{$ii.$d[5]}==0 && $change_cal==1) {print (F10 "A ",$d[3],$d[4],$ii.$d[5]," to ",$i_cal);$n_log{$ii.$d[5]}=1}
                                                                   }
if ($d_elev[$i_cal]*1==0 ) {
if ($d_elev[1]>0) {$i_cal=1}
if ($n_log{$ii.$d[5]}==0) {print (F10 "B ",$d[3],$d[4],$ii.$d[5]," to ",$i_cal);$n_log{$ii.$d[5]}=1}
                           }
if ($d_elev[$i_cal]>0) {
$zen_index=int((90-$d[26])/$d_elev[$i_cal])+1;
$ant_cal_value=$ant_cal{$i_cal." ".$zen_index}+(90-$d[26]-($zen_index-1)*$d_elev[$i_cal])*($ant_cal{$i_cal." ".eval($zen_index+1)}-$ant_cal{$i_cal." ".$zen_index})/$d_elev[$i_cal];
                         }
                      }
#######################


$pc_sta[$i]=0;

        for $j (1..3) {
        $pc_sta[$i] += $d[13+$j]*$pc{$i_cal." ".$j}
                       }

##### For each carrier phase the residual is computed
#### L = rho+trop+rel-sat_pc-tide-sta_pc+windup
####         ^--- corr1 ---^
$l[$i]=$d[6+$i]-($d[18]+$corr1+$windup[$i]-$tide_corr-1*$pc_sta[$i]+$ant_cal_value);
$p[$i]=$d[8+$i]-($d[18]+$corr1-$tide_corr-1*$pc_sta[$i]+$ant_cal_value);

####for $i (1..$freq_num
                      }
                  }

if ($freq_num==3) {
$corr1=$d[22]+$d[23]-$d[24];

## tide
$tide_corr=0;
for $j (1..3) {$tide_corr += $d[16+$j]*$tide[$j]}

### windup and sta_pc
for $i (1..$freq_num) {

$ii=$f_[$i];
$windup[$i]=$d[22]*$c_light/$f[$ii]/4/atan2(1,0);


##### Antenna Calibration Value
##
$i_cal=$f_[$i];

if ($d_elev[$i_cal]*1==0 && ($i_cal==7 || $i_cal==8 || $i_cal==5)) {
if ($d_elev[5]>0) {$i_cal=5}
if ($d_elev[7]>0) {$i_cal=7}
if ($d_elev[8]>0) {$i_cal=8}
if ($n_log{$ii.$d[5]}==0 && $d_elev[$i_cal]>0) {
          print (F10 "C ",$d[3],$d[4],$ii.$d[5]," to ",$i_cal);$n_log{$ii.$d[5]}=1
                                         }
                                                                   }

if ($d_elev[$i_cal]*1==0) {
if ($d_elev[1]>0) {$i_cal=1}
if ($n_log{$ii.$d[5]}==0) {
            print (F10 "D ",$d[4],$ii.$d[5]," to ",$i_cal);$n_log{$ii.$d[5]}=1
                          }

                          }

if ($d_elev[$i_cal]>0) {
$zen_index=int((90-$d[26])/$d_elev[$i_cal])+1;
$ant_cal_value=$ant_cal{$i_cal." ".$zen_index}+(90-$d[26]-($zen_index-1)*$d_elev[$i_cal])*($ant_cal{$i_cal." ".eval($zen_index+1)}-$ant_cal{$i_cal." ".$zen_index})/$d_elev[$i_cal];
                       }

########################
#
$pc_sta[$i]=0;
        for $j (1..3) {
        $pc_sta[$i] += $d[16+$j]*$pc{$i_cal." ".$j}
                       };


##### For each carrier phase the residual is computed
#### L = rho+trop+rel-sat_pc-tide-sta_pc+windup
####         ^--- corr1 ---^
$l[$i]=$d[6+$i]-($d[21]+$corr1+$windup[$i]-$tide_corr-$pc_sta[$i]+$ant_cal_value);
$p[$i]=$d[9+$i]-($d[21]+$corr1-$tide_corr-$pc_sta[$i]+$ant_cal_value);

####for $i (1..$freq_num
                      }
                  }
################# END of computing the residuals

################# START TO WRITE THE RESIDUALS
if ($freq_num==2) {
printf (F2 "%2d %3d %6d %4s %3s %2d %14.4f %14.4f %14.4f %14.4f %3d %2d %2d %11.8f %11.8f %11.8f %11.8f %11.8f %11.8f %11.8f %5.2f %14.4f %14.4f\n",@d[1..6],@l,@p,@d[11..17],@d[23..26],-1*($d[27]+$d[29]),-1*($d[28]+$d[29]));                       
                  }
if ($freq_num==3) {
printf (F2 "%2d %3d %6d %4s %4s %2d %14.4f %14.4f %14.4f %14.4f %14.4f %14.4f %3d %2d %2d %2d %11.8f %11.8f %11.8f %11.8f %11.8f %11.8f %11.8f %5.2f %14.4f %14.4f %14.4f\n",@d[1..6],@l,@p,@d[13..20],@d[26..29],-1*($d[30]+$d[33]),-1*($d[31]+$d[33]),-1*($d[32]+$d[33]));
                  }


####################################################

            }
